clearvars
%You must edit your local path to the data folder.
%350ms ITI, comment one or the other condtion to switch analyses.
eval('!ls ~/Desktop/MatlabCode/AnnandHoldenRawRandSeqData/SequenceDepend350/?????.csv > ~/Desktop/fileListRG_350.txt'); 
list=textread('~/Desktop/fileListRG_350.txt','%s');
%700ms ITI
%eval('!ls /Desktop/MatlabCode/AnnandHoldenRawRandSeqData/SequenceDepend700/?????.csv > /YOUR_PATH_TO/Desktop/fileListRG_700.txt'); 
%list=textread('/YOUR_PATH_TO/Desktop/fileList700_350.txt','%s');


N=size(list,1);
lo_rt=1;
hi_rt=2000;
tcnts=zeros(62,N);
%Fro data analysis.
slen=[5	4	5	3	5	4	5	2	5	4	5	3	5	4	5	1	5	4	5	3	5	4	5	2	5	4	5	3	5	4	5];
rlslen=repmat(slen,1,2)';
mrt=zeros(length(rlslen),N); Ecount=zeros(length(rlslen),N);
TotErrors=NaN(1,N);
%spectra
out=zeros(N,2);
spID=zeros(127,N);
spRT=zeros(127,N);

for i=1:N
    
filename=char(list(i,:));
        FID1=fopen(filename);
        %Sub Cnd Blk Trial Order Resp Name Stim RT Correct
        % 1   2   3    4     5    6     7    8   9   10
        [DyadCellSes1]=textscan(FID1,'%s %d %d %d %d %d %s %s %d %s',...
        'headerlines',1,'emptyvalue',NaN,'delimiter',',');   
    fclose(FID1);
    %Pull the varables
    DRT=double(DyadCellSes1{9}(1:1600));
    key=(double(DyadCellSes1{6}(1:1600))-203)./2;
    %No errors possible
    DRT(DRT==0)=1;
    dTS=[key DRT];
   
    % Skip subs with 7.5% errors, or MRT>800ms
   % if  (sum(dTS(:,2)<0)> 132) || (mean(dTS(dTS(:,2)>200,2))> 1100)
   %     continue
  %  else
        %insert call to seq search, returns 31XNtrials*.75 matix with
        %The RTs in sucessive sequence order e.g., RRRR,RRRR, etc for all
        %pattern 1.
        TotErrors(1,i)=sum(dTS(:,1)==1 & dTS(:,2)<0)/sum(dTS(:,1)==1);
        out=SeqSearchRandLleading(dTS);
        %Data analysis on MRT is taken on all trial correct seq. Error
        %counts come from seq with errors, only counted 1 time. So several
        %seq that share same error RT won't be counted.
        %Sequence lengths:
        for j=1:length(rlslen)  
            data=out(j,:); data(isnan(data))=[]; data(data==0)=[];
            
            vlen=length(data);
            if rlslen(j)==1
              %case of single R trials.
              Ecount(j,i)=(sum(data>0)); %(sum(data<0))/length(data);
              data(data < lo_rt | data > hi_rt)=[];
              mrt(j,i)=mean(data);

            elseif rem(vlen,rlslen(j))==0
                %case of seq 2-5 in length
                 data=reshape(data,rlslen(j),vlen/rlslen(j))';
                 Ecount(j,i)=length(data); %(length( unique( data(data<0) ) )) /length(data(:));
                 [r,~]=find(data < lo_rt | data > hi_rt);
                 data(r,:)=[];
                 mrt(j,i)=mean(data(:));     
            else  %case of uneven number of trials
                %Ecount(j,i)=0;
                disp(['SUB ' num2str(i) ' Seq ' num2str(j) ' uneven length'])
            end
        end
end


 
 
%Search for Skipped subjects, remove their cols in RT and Errors.
[~,C]=find(mrt==0); mrt(:,unique(C)')=[]; Ecount(:,unique(C)')=[];

save ~/Desktop/RandL350Counts.txt Ecount -ascii -tabs
