%% Preliminaries
clearvars

%The filenames 
list=textread('~/Desktop/MatlabCode/RandGenBoth350and700SortXScExpforIAAFT.txt','%s');

N=size(list,1);
lo_rt=0;
hi_rt=2000;
%Fro data analysis.
slen=[5	4	5	3	5	4	5	2	5	4	5	3	5	4	5	1	5	4	5	3	5	4	5	2	5	4	5	3	5	4	5];
mrt=zeros(31,N); Ecount=zeros(31,N);
TotErrors=NaN(1,N);
%spectra
rout=zeros(N,6);
out=zeros(N,2);
spID=zeros(127,N);
spRT=zeros(127,N);
SimOut=zeros(1600,N);

for i=1:N
    
filename=char(list(i,:));
        FID1=fopen(filename);
        %Sub Cnd Blk Trial Order Resp Name Stim RT Correct
        % 1   2   3    4     5    6     7    8   9   10
        [DyadCellSes1]=textscan(FID1,'%s %d %d %d %d %d %s %s %d %s',...
        'headerlines',1,'emptyvalue',NaN,'delimiter',',');   
    fclose(FID1);
    %Pull the varables
    if 1600 ~= length(DyadCellSes1{9})
        continue
    else
    end
    
    DRT=double(DyadCellSes1{9}(1:1600));
    key=(double(DyadCellSes1{6}(1:1600))-203)./2;
    %No errors possible
    DRT(DRT==0)=1;
    dTS=[key DRT];
    out(i,1)=spec_expon(normalize(dTS(101:1124,1)),128,.5);
    [y,iter]=iaaft(dTS(:,1),1,150);
%     [F,P]=spec_values(normalize(dTS(101:1124,1)),256);
%    plot(F,P,'-','Color',[.0 .0 .0])
%    %set(gcf, 'Units', 'Normalized', 'OuterPosition', [0 0 1 1]);
%    display(num2str(i));
%    drawnow, pause
   [~,~,~,rout(i,1:6)]=rqa(y(101:1124),5,0,5);
   %out(i,1)=spec_expon(normalize(dTS(101:1124,1)),128,.5);
   out(i,2)=dfa(normalize(y(101:1124,1)),0,0,0);
        % subplot(3,1,1)
        %plot(1:length(x),x)
        subplot(3,1,2)
        plot(1:length(y),y)
        subplot(3,3,7)
        spec_slope_drw(normalize(y(101:1124)),128,.5);
        subplot(3,3,9)
        [~,~,~,rout(i,1:6)]=rqa(y(101:1124),5,0,5); axis([400 550 400 550])
        SimOut(:,i)=y;
        %         subplot(3,3,8)
%         histogram(x,30)
   %drawnow, pause
end  

subplot(3,3,8)
histogram(out(:,2),15)

%%Data Analysis
Q=1./(rout(:,1)./100); Lmd=rout(:,4)./1004; SDpi=sqrt(Q./(2.*Lmd));
disp([mean(out(:,1)),mean(out(:,2)),mean(Q),mean(Lmd),mean(SDpi)])
diffs=count_RandGENBimanModSeqDep(SimOut);
%subplot(3,3,8)
bar(diffs(1:62,1))
[out, Q, Lmd, SDpi]