function diffs=count_RandGENBimanModSeqDep(SimOut)
clearvars
% THis file searches the bimanual coord sim output, this first row are the
% counts for 100 1600X1 random zero-one vectors, to shortcut recalculating.
RandCounts=[51	101	50	201	50	100	50	402	50	100	50	200	50	100	49	803	50	100	50	200	50	100	50	400	50	100	50	200	51	100	49	50	100	50	200	50	100	49	400	50	100	50	200	50	100	50	797	50	101	50	200	49	99	50	396	50	100	49	196	49	96	48]';

N=size(SimOut,2);
lo_rt=1; hi_rt=1000;
%tcnts=zeros(62,100);
%Fro data analysis.
slen=[5	4	5	3	5	4	5	2	5	4	5	3	5	4	5	1	5	4	5	3	5	4	5	2	5	4	5	3	5	4	5];
slen=[slen,slen];
mrt=zeros(62,N); Ecount=zeros(62,N);

 %TotErrors=NaN(1,N);
 for i=1:N
%     
% filename=char(list(i,:));
%         FID1=fopen(filename);
%         %Sub Cnd Blk Trial Order Resp Name Stim RT Correct
%         % 1   2   3    4     5    6     7    8   9   10
%         [DyadCellSes1]=textscan(FID1,'%s %d %d %d %d %d %s %s %d %s',...
%         'headerlines',1,'emptyvalue',NaN,'delimiter',',');   
%     fclose(FID1);
%     %Pull the varables
%     if 1600 ~= length(DyadCellSes1{9})
%         continue
%     else
%     end
%     
%     DRT=double(DyadCellSes1{9}(1:1600));
%     key=(double(DyadCellSes1{6}(1:1600))-203)./2;
    %No errors possible
   
    %dTS=[key DRT];
     dTS=[SimOut(:,i), ones(1600,1)*500]; %RT fixed to arbitrary 500, since search code assumes 2 cols. 
%     % Skip subs with 7.5% errors, or MRT>800ms
% %     if  (sum(dTS(:,2)<0)> 83) || (mean(dTS(dTS(:,2)>200,2))> 800)
% %         continue
% %     else
%         %insert call to seq search, returns 31XNtrials*.75 matix with
%         %The RTs in sucessive sequence order e.g., RRRR,RRRR, etc for all
%         %pattern 1.
%           TotErrors(1,i)=sum(dTS(:,1)==1 & dTS(:,2)>0)/1600;
%         out=testSeqSearch(dTS);
         out=SeqSearchRandLleading(dTS);
            out(out==0)=NaN;
%         %Data analysis on MRT is taken on all trial correct seq. Error
%         %counts come from seq with errors, only counted 1 time. So several
%         %seq that share same error RT won't be counted.
%         %Sequence lengths:
        parfor j=1:62
            data=out(j,:); data(isnan(data))=[]; data(data==0)=[];
            vlen=length(data);
            if slen(j)==1
              %case of single R trials.
              Ecount(j,i)=(sum(data>0));
              data(data < lo_rt | data > hi_rt)=[];
              mrt(j,i)=mean(data);

            elseif rem(vlen,slen(j))==0
                %case of seq 2-5 in length
                 data=reshape(data,slen(j),vlen/slen(j))';
                 Ecount(j,i)=length(data);
                 [r,~]=find(data < lo_rt | data > hi_rt);
                 data(unique(r),:)=[];
                 mrt(j,i)=mean(data(:));
            else  %case of uneven number of trials
                disp(['SUB ' num2str(i) ' Seq ' num2str(j) ' uneven length'])
            end
        end
    %end
%     
 end
% 
 %Search for Skipped subjects, remove their cols in RT and Errors.
[~,C]=find(mrt==0); mrt(:,unique(C)')=[]; Ecount(:,unique(C)')=[];
diffs=round(mean(Ecount,2),0)-RandCounts;
save ~/Desktop/BiManCounts.txt Ecount -ascii -tabs

