function [sexp]=spec_expon(z,nfreq,spec_portion)
%returns the slope of the powerspectrum
%function [pslp]=spec_slope(z,nfreq,spec_portion);
%default nfreq=128, default portion=1
if nargin == 1
	nfreq=128;
    spec_portion=1;  
else
end

[P,F]=pwelch(z,triang(2*nfreq),nfreq,2*nfreq,1,'onesided');
%[P, F] = spectrum(z,2*nfreq,nfreq,triang(2*nfreq),1,.95,'none');
F(1)=[];
F(nfreq)=[];
P(1,:)=[];
%P(:,2)=[];
P(nfreq,:)=[];
P=log10(P);
F=log10(F);
[p,~]=polyfit(F(1:floor(length(F)*spec_portion)),P(1:floor(length(P)*spec_portion)),1);
sexp=-1*p(1,1);


